static const char* const rcsid = "$Id$";
/*                               -*- Mode: C -*- 
 * data-tg.c -- 
 * 
 * Copyright (C) 1999-2005 LAAS/CNRS
 * 
 * Author          : Francois Felix Ingrand
 * Created On      : Fri Jul  9 10:07:12 1999
 * Last Modified By: Francois Felix Ingrand
 * Last Modified On: Fri Sep 17 17:46:11 1999
 * Update Count    : 30
 * Status          : OK
 * 
 * $Id$
 */

#include "config.h"

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "slistPack.h"
#include "slistPack_f.h"

#include "macro.h"
#include "transgen.h"
#include "transgen_f.h"
#include "perl-build_f.h"

#define DATA_INC "data.inc"
#define INIT_OP "init.op"


PBoolean data_transgen(FILE *perl_file)
{
     Module *module;
     char *modules_data, *superv_data,
	  *modules_require;

     modules_data = superv_data = modules_require = NULL;

     script_open(perl_file);
     subst_begin(perl_file, DATA_INC);
     
     print_sed_subst(perl_file, "open-prs-data", "%s", OPRS_DATA_DIR);
     print_sed_subst(perl_file, "transgen-data", "%s", TRANSGEN_DATA_DIR);
     print_sed_subst(perl_file, "superv-data", "%s/auto/data", supervisor->dir);
     print_sed_subst(perl_file, "user-data", "%s/data", supervisor->dir);
     print_sed_subst(perl_file, "superv-name", supervisor->name);
     print_sed_subst(perl_file, "modules-data", "%s", MODULES_DATA_DIR);

     sl_loop_through_slist(supervisor->mod_list, module, Module *) {
	  bufcat(&modules_require,
		 "\nrequire \"%sOpenprs.inc\"",
		 module->name);

     }

     if (modules_require) {
	  print_sed_subst(perl_file, "modules-require", modules_require);
	  FREE(modules_require);
     } else {
	  print_sed_subst(perl_file, "modules-require", "");
     }

     subst_end(perl_file);
     script_close(perl_file, "auto/data/%s-" DATA_INC, supervisor->name);

     return TRUE;
}
